#include <stdio.h>
#include <stdlib.h>
#include <SDL/SDL.h>
#include <SDL/SDL_image.h>

#include "constantes.h"
#include "savload.h"

int loadMap(short **carte, short **mur, short **air, short **contenu, int *nbPixelX, int *nbPixelY, int *nbMotifsAeriens, int *nbContenu, int map)
{
    FILE* fichier=NULL;
    char nomFichier[50]="";
    sprintf(nomFichier, "map/carte%ld.map", map);
    fichier=fopen(nomFichier, "r");
    if (fichier==NULL)
        return 0;
    int i=0, j=0, k=0, npixelx=0, npixely=0, valeurActuel=0, nbMotifsAeriens2=0, nbContenu2=0, x=0, y=0;

    fscanf(fichier, "%ld\n%ld\n", &npixelx, &npixely);
    *nbPixelX=npixelx;
    *nbPixelY=npixely;

    for (i=0; i<npixelx/16; i++){
    for (j=0; j<npixely/16; j++){
        fscanf(fichier, "%ld\n", &carte[i][j]);
        fscanf(fichier, "%ld\n", &mur[i*2][j*2]);
        fscanf(fichier, "%ld\n", &mur[i*2+1][j*2]);
        fscanf(fichier, "%ld\n", &mur[i*2][j*2+1]);
        fscanf(fichier, "%ld\n", &mur[i*2+1][j*2+1]);
    }
    }

    fscanf(fichier, "%ld\n", &nbMotifsAeriens2);
    for (i=0; i<nbMotifsAeriens2; i++) {
        fscanf(fichier, "%ld\n", &x);
        fscanf(fichier, "%ld\n", &y);
        fscanf(fichier, "%ld\n", &air[x][y]);
        if (map==0)
            fprintf(stderr, "Air[x][y]=%ld\n", air[x][y]);
    }

    fscanf(fichier, "%ld\n", &nbContenu2);
    for (i=0; i<nbContenu2; i++) {
        fscanf(fichier, "%ld\n", &x);
        fscanf(fichier, "%ld\n", &y);
        fscanf(fichier, "%ld\n", &contenu[x][y]);
    }
    *nbMotifsAeriens=nbMotifsAeriens2;
    *nbContenu=nbContenu2;
    fclose(fichier);
    return 1;
}

int savMap(short **carte, short **mur, short **air, short **contenu, int *nbPixelX, int *nbPixelY, int *nbMotifsAeriens, int *nbContenu, int map)
{
    FILE* fichier=NULL;
    char nomFichier[50]="";
    sprintf(nomFichier, "map/carte%ld.map", map);
    fichier=fopen(nomFichier, "w");
    if (fichier==NULL)
        return 0;
    int i=0, j=0, k=0, npixelx=0, npixely=0, valeurActuel=0, nbMotifsAeriens2=0, nbContenu2=0, x=0, y=0;

    fprintf(fichier, "%ld\n%ld\n", *nbPixelX, *nbPixelY);

    for (i=0; i<*nbPixelX/16; i++){
    for (j=0; j<*nbPixelY/16; j++){
        fprintf(fichier, "%ld\n", carte[i][j]);
        fprintf(fichier, "%ld\n", mur[i*2][j*2]);
        fprintf(fichier, "%ld\n", mur[i*2+1][j*2]);
        fprintf(fichier, "%ld\n", mur[i*2][j*2+1]);
        fprintf(fichier, "%ld\n", mur[i*2+1][j*2+1]);
    }
    }

    fprintf(fichier, "%ld\n", *nbMotifsAeriens);
    for (i=0; i<*nbPixelX/16; i++){
    for (j=0; j<*nbPixelY/16; j++){
        if (air[i][j]!=0)
        {
            fprintf(fichier, "%ld\n", i);
            fprintf(fichier, "%ld\n", j);
            fprintf(fichier, "%ld\n", air[i][j]);
        }
    }
    }

    fprintf(fichier, "%ld\n", *nbContenu);
    for (i=0; i<*nbPixelX/16; i++){
    for (j=0; j<*nbPixelY/16; j++){
        if (contenu[i][j]!=0)
        {
            fprintf(fichier, "%ld\n", i);
            fprintf(fichier, "%ld\n", j);
            fprintf(fichier, "%ld\n", contenu[i][j]);
        }
    }
    }
    fclose(fichier);
    return 1;
}

int loadObject(short **carte, short **mur, short **air, short **contenu, int *nbPixelX, int *nbPixelY, int *nbMotifs, int *nbCollisions, int *nbMotifsAeriens, int *nbContenu, int objet)
{
    FILE* fichier=NULL;
    char nomFichier[50]="";
    sprintf(nomFichier, "object/objet%ld.obj", objet);
    fichier=fopen(nomFichier, "r");
    if (fichier==NULL)
        return 0;
    int i=0, j=0, k=0, npixelx=0, npixely=0, valeurActuel=0, nbMotifs2, nbCollisions2, nbMotifsAeriens2=0, nbContenu2=0, x=0, y=0, valeur=0;

    fscanf(fichier, "%ld\n%ld\n", &npixelx, &npixely);
    *nbPixelX=npixelx;
    *nbPixelY=npixely;

    fscanf(fichier, "%ld\n", &nbMotifs2);
    for (i=0; i<nbMotifs2; i++){
        fscanf(fichier, "%ld\n", &x);
        fscanf(fichier, "%ld\n", &y);
        fscanf(fichier, "%ld\n", &valeur);
        carte[x][y]=valeur;
    }

    fscanf(fichier, "%ld\n", &nbCollisions2);
    for (i=0; i<nbCollisions2; i++){
        fscanf(fichier, "%ld\n", &x);
        fscanf(fichier, "%ld\n", &y);
        fscanf(fichier, "%ld\n", &valeur);
        mur[x][y]=valeur;
    }

    fscanf(fichier, "%ld\n", &nbMotifsAeriens2);
    for (i=0; i<nbMotifsAeriens2; i++) {
        fscanf(fichier, "%ld\n", &x);
        fscanf(fichier, "%ld\n", &y);
        fscanf(fichier, "%ld\n", &valeur);
        air[x][y]=valeur;
    }

    fscanf(fichier, "%ld\n", &nbContenu2);
    for (i=0; i<nbContenu2; i++) {
        fscanf(fichier, "%ld\n", &x);
        fscanf(fichier, "%ld\n", &y);
        fscanf(fichier, "%ld\n", &valeur);
        contenu[x][y]=valeur;
    }
    *nbMotifs=nbMotifs2;
    *nbCollisions=nbCollisions2;
    *nbMotifsAeriens=nbMotifsAeriens2;
    *nbContenu=nbContenu2;
    fclose(fichier);
    return 1;
}

int savObject(short **carte, short **mur, short **air, short **contenu, int *nbPixelX, int *nbPixelY, int *nbMotifs, int *nbCollisions, int *nbMotifsAeriens, int *nbContenu, int objet)
{
    FILE* fichier=NULL;
    char nomFichier[50]="";
    sprintf(nomFichier, "object/objet%ld.obj", objet);
    fichier=fopen(nomFichier, "w");
    if (fichier==NULL)
        return 0;
    int i=0, j=0, k=0, npixelx=0, npixely=0, valeurActuel=0, nbMotifsAeriens2=0, nbContenu2=0, x=0, y=0;

    fprintf(fichier, "%ld\n%ld\n", *nbPixelX, *nbPixelY);

    fprintf(fichier, "%ld\n" , *nbMotifs);
    for (i=0; i<*nbPixelX/16; i++){
    for (j=0; j<*nbPixelY/16; j++){
        if (carte[i][j]!=-1)
        {
            fprintf(fichier ,"%ld\n", i);
            fprintf(fichier, "%ld\n", j);
            fprintf(fichier, "%ld\n", carte[i][j]);
        }
    }
    }

    fprintf(fichier, "%ld\n" , *nbCollisions);
    for (i=0; i<*nbPixelX/8; i++){
    for (j=0; j<*nbPixelY/8; j++){
        if (mur[i][j]!=0)
        {
            fprintf(fichier ,"%ld\n", i);
            fprintf(fichier, "%ld\n", j);
            fprintf(fichier, "%ld\n", mur[i][j]);
        }
    }
    }

    fprintf(fichier, "%ld\n", *nbMotifsAeriens);
    for (i=0; i<*nbPixelX/16; i++){
    for (j=0; j<*nbPixelY/16; j++){
        if (air[i][j]!=0)
        {
            fprintf(fichier, "%ld\n", i);
            fprintf(fichier, "%ld\n", j);
            fprintf(fichier, "%ld\n", air[i][j]);
        }
    }
    }

    fprintf(fichier, "%ld\n", *nbContenu);
    for (i=0; i<*nbPixelX/16; i++){
    for (j=0; j<*nbPixelY/16; j++){
        if (contenu[i][j]!=0)
        {
            fprintf(fichier, "%ld\n", i);
            fprintf(fichier, "%ld\n", j);
            fprintf(fichier, "%ld\n", contenu[i][j]);
        }
    }
    }
    fclose(fichier);
    return 1;
}
